      program decompose


C This program decomposes the cluster trajectory output into individual trajectories

      parameter(maxpoint=10000,maxt=120)
      real xinit(maxpoint),yinit(maxpoint),zinit(maxpoint)
      real x(maxt,maxpoint),y(maxt,maxpoint),z(maxt,maxpoint)
      real topo(maxt,maxpoint),hmix(maxt,maxpoint),tropo(maxt,maxpoint)
      real pv(maxt,maxpoint),rmsdist(maxt,maxpoint),rms(maxt,maxpoint)
      real zrms(maxt,maxpoint),zrmsdist(maxt,maxpoint)
      real hfr(maxt,maxpoint),pvfr(maxt,maxpoint),trfr(maxt,maxpoint)
      real xclusti(5),yclusti(5),zclusti(5),fclusti(5),rmsclusti(5)
      real xclust(maxt,maxpoint,5),yclust(maxt,maxpoint,5)
      real zclust(maxt,maxpoint,5),fclust(maxt,maxpoint,5)
      real rmsclust(maxt,maxpoint,5)
      integer itt(maxt,maxpoint)
      integer itimerel(maxpoint),npart(maxpoint) 
      double precision juldate,julstart,jul(maxpoint)

      open(10,file='trajectories.txt',status='old')
      open(20,file='sorted_trajectories.txt')
      read(10,*) ibdate,ibtime
      julstart=juldate(ibdate,ibtime)
      read(10,*)
      read(10,*) numpoint
      do 10 i=1,numpoint
        read(10,*) i1,i2,xp1,yp1,xp2,yp2,zp1,zp2,k,npart(i)
        itimerel(i)=(i1+i2)/2
        jul(i)=julstart+dble(float(itimerel(i))/86400.)
        xinit(i)=(xp1+xp2)/2.
        yinit(i)=(yp1+yp2)/2.
        zinit(i)=(zp1+zp2)/2.
10      read(10,*)


100   read(10,'(i5,i8,2f9.4,4f8.1,f8.2,4f8.1,3f6.1,
     +5(2f8.3,f7.0,f6.1,f8.1)))',end=99,err=99)
     +j,it1,xi,yi,zi,topoi,hmixi,tropoi,pvi,rmsdisti,
     +rmsi,zrmsdisti,zrmsi,hfri,pvfri,trfri,(xclusti(k),yclusti(k),
     +zclusti(k),fclusti(k),rmsclusti(k),k=1,5)
      it=abs(it1)/10800
      if (it.eq.0) goto 100
      itt(it,j)=it1
      x(it,j)=xi
      y(it,j)=yi
      z(it,j)=zi
      topo(it,j)=topoi
      hmix(it,j)=hmixi
      tropo(it,j)=tropoi
      pv(it,j)=pvi
      rmsdist(it,j)=rmsdisti
      rms(it,j)=rmsi
      zrmsdist(it,j)=zrmsdisti
      zrms(it,j)=zrmsi
      hfr(it,j)=hfri
      pvfr(it,j)=pvfri
      trfr(it,j)=trfri
      do 25 k=1,5
        xclust(it,j,k)=xclusti(k)
        yclust(it,j,k)=yclusti(k)
        zclust(it,j,k)=zclusti(k)
        rmsclust(it,j,k)=rmsclusti(k)
25      fclust(it,j,k)=fclusti(k)
      goto 100

99    continue

      do 30 j=1,numpoint
        call caldate(jul(j),ij,im)
        write(20,'(i8,1x,i6,1x,i5)') ij,im,81
        write(20,'(i7,2f9.4,4f8.1,f8.2,4f8.1,3f6.1,
     +  5(2f8.3,f7.0,f6.1,f8.1))')
     +  0,xinit(j),yinit(j),zinit(j),-999.,-999.,-999.,-999.,-999.,-999.
     +  ,-999.,-999.,-9.9,-9.9,-9.9,(-99.,k=1,25)
        do 30 it=1,80
30      write(20,'(i7,2f9.4,4f8.1,f8.2,4f8.1,3f6.1,
     +    5(2f8.3,f7.0,f6.1,f8.1))')
     +    itt(it,j),x(it,j),y(it,j),z(it,j),topo(it,j),hmix(it,j),
     +    tropo(it,j),pv(it,j),rmsdist(it,j),rms(it,j),zrmsdist(it,j),
     +    zrms(it,j),hfr(it,j),pvfr(it,j),trfr(it,j),(xclust(it,j,k),
     +    yclust(it,j,k),zclust(it,j,k),fclust(it,j,k),rmsclust(it,j,k),
     +    k=1,5)
     


      end



      FUNCTION juldate(YYYYMMDD,HHMISS)
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                                             *
*     Calculates the Julian date                                              *
*                                                                             *
*     AUTHOR: Andreas Stohl (15 October 1993)                                 *
*                                                                             *
*     Variables:                                                              *
*     DD             Day                                                      *
*     HH             Hour                                                     *
*     HHMISS         Hour, minute + second                                    *
*     JA,JM,JY       help variables                                           *
*     juldate        Julian Date                                              *
*     JULDAY         help variable                                            *
*     MI             Minute                                                   *
*     MM             Month                                                    *
*     SS             Second                                                   *
*     YYYY           Year                                                     *
*     YYYYMMDDHH     Date and Time                                            *
*                                                                             *
*     Constants:                                                              *
*     IGREG          help constant                                            *
*                                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      IMPLICIT NONE

      INTEGER YYYYMMDD,YYYY,MM,DD,HH,MI,SS,HHMISS
      INTEGER JULDAY,JY,JM,JA,IGREG
      REAL*8 juldate
      PARAMETER (IGREG=15+31*(10+12*1582))

      YYYY=YYYYMMDD/10000
      MM=(YYYYMMDD-10000*YYYY)/100
      DD=YYYYMMDD-10000*YYYY-100*MM
      HH=HHMISS/10000
      MI=(HHMISS-10000*HH)/100
      SS=HHMISS-10000*HH-100*MI

      IF (YYYY.EQ.0) PAUSE 'There is no Year Zero.'
      IF (YYYY.LT.0) YYYY=YYYY+1
      IF (MM.GT.2) THEN
        JY=YYYY
        JM=MM+1
      ELSE
        JY=YYYY-1
        JM=MM+13
      ENDIF
      JULDAY=INT(365.25*JY)+INT(30.6001*JM)+DD+1720995
      IF (DD+31*(MM+12*YYYY).GE.IGREG) THEN
        JA=INT(0.01*JY)
        JULDAY=JULDAY+2-JA+INT(0.25*JA)
      ENDIF

      juldate=DBLE(FLOAT(JULDAY))+DBLE(FLOAT(HH)/24.)+
     +DBLE(FLOAT(MI)/1440.)+DBLE(FLOAT(SS)/86400.)

      RETURN
      END


      SUBROUTINE caldate(juldate,YYYYMMDD,HHMISS)
c                           i       o       o
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                                             *
*     Calculates the Gregorian date from the Julian date                      *
*                                                                             *
*     AUTHOR: Andreas Stohl (21 January 1994), adapted from Numerical Recipes *
*                                                                             *
*     Variables:                                                              *
*     DD             Day                                                      *
*     HH             Hour                                                     *
*     HHMISS         Hour, Minute, Second                                     *
*     JA,JB,JC,JD,JE help variables                                           *
*     JALPHA         help variable                                            *
*     juldate        Julian Date                                              *
*     JULDAY         help variable                                            *
*     MI             Minute                                                   *
*     MM             Month                                                    *
*     SS             Seconds                                                  *
*     YYYY           Year                                                     *
*     YYYYMMDD       Year, Month, Day                                         *
*                                                                             *
*     Constants:                                                              *
*     IGREG          help constant                                            *
*                                                                             *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

      IMPLICIT NONE

      INTEGER YYYYMMDD,YYYY,MM,DD,HHMISS,HH,MI,SS
      INTEGER JULDAY,JA,JB,JC,JD,JE,IGREG,JALPHA
      REAL*8 juldate
      PARAMETER (IGREG=2299161)

      JULDAY=INT(juldate)
      IF(JULDAY.GE.IGREG)THEN
        JALPHA=INT(((JULDAY-1867216)-0.25)/36524.25)
        JA=JULDAY+1+JALPHA-INT(0.25*JALPHA)
      ELSE
        JA=JULDAY
      ENDIF
      JB=JA+1524
      JC=INT(6680.+((JB-2439870)-122.1)/365.25)
      JD=365*JC+INT(0.25*JC)
      JE=INT((JB-JD)/30.6001)
      DD=JB-JD-INT(30.6001*JE)
      MM=JE-1
      IF (MM.GT.12) MM=MM-12
      YYYY=JC-4715
      IF (MM.GT.2) YYYY=YYYY-1
      IF (YYYY.LE.0) YYYY=YYYY-1

      YYYYMMDD=10000*YYYY+100*MM+DD
      HH=INT(24.*(juldate-FLOAT(JULDAY)))
      MI=INT(1440.*(juldate-FLOAT(JULDAY))-60.*FLOAT(HH))
      SS=NINT(86400.*(juldate-FLOAT(JULDAY))-3600.*FLOAT(HH))
     +-60.*FLOAT(MI)
      IF (SS.EQ.60) THEN  ! 60 seconds = 1 minute
        SS=0
        MI=MI+1
      ENDIF
      IF (MI.EQ.60) THEN
        MI=0
        HH=HH+1
      ENDIF
      HHMISS=10000*HH+100*MI+SS

      RETURN
      END
