      real function scalev(ps,t,td,stress)
*********************************************************************
*                                                                   *
*                       Author: G. WOTAWA                           *
*                       Date:   1994-06-27                          *
*                       Update: 1996-05-21 A. Stohl                 *
*                                                                   *
*********************************************************************
*                                                                   *
*     This Programm calculates scale velocity ustar from surface    *
*     stress and air density.                                       *
*                                                                   *
*********************************************************************
*                                                                   *
*     INPUT:                                                        *
*                                                                   *
*     ps      surface pressure [Pa]                                 * 
*     t       surface temperature [K]                               * 
*     td      surface dew point [K]                                 *
*     stress  surface stress [N/m2]                                 *
*                                                                   *
*********************************************************************
*
      include 'includepar'

      real ps,t,td,e,ew,tv,rhoa,stress

      e=ew(td)                       ! vapor pressure
      tv=t*(1.+0.378*e/ps)           ! virtual temperature
      rhoa=ps/(r_air*tv)              ! air density
      scalev=sqrt(abs(stress)/rhoa)

      end
