      subroutine sigma(x,xs,number)        
********************************************************************************
*                                                                              *
*  This subroutine calculates mean and standard deviation of a given element.  *
*                                                                              *
*      AUTHOR: Andreas Stohl, 25 January 1994                                  *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
* x(number)           field of input data                                      *
* xs                  standard deviation                                       *
* number              number of elements of field x                            *
*                                                                              *
* Constants:                                                                   *
* eps                 tiny number                                              *
*                                                                              *
********************************************************************************

      integer number,i
      real x(number),xs,xl,xq,eps,xaux
      parameter(eps=1.0e-30)

      xl=x(1)
      xq=x(1)*x(1)
      do 10 i=2,number
        xl=xl+x(i)
10      xq=xq+x(i)*x(i)

      xaux=xq-xl*xl/float(number)

      if (xaux.lt.eps) then
        xs=0.
      else
        xs=sqrt(xaux/float(number-1))
      endif

      end
